/***********************************(AQM1248A_v4npf.c)*******
 *     AQM1248A OtBbNCuispi-vRamtj
 **********************************************************/

#include "myProject.h"
#include "Font_5x7.h"

#define VRAM_ADR    0x80000
#define LCG_C_SIZE  128
#define HASC_OFS    0x00200
#define H_BLANK     0x007F0

static uint8_t vBf[32];			// tHgp^[pobt@[
static uint8_t uMap[128];

//--- SPI-vRam ANZX֐
uint8_t vRam_read(uint8_t xpos, uint8_t ypos){
	uint32_t adr;
	adr = VRAM_ADR + (uint32_t)ypos * LCG_C_SIZE + xpos;
	return SPI_Mem_Read(adr);
}

void vRam_write(uint8_t xpos, uint8_t ypos, uint8_t dat){
	uint32_t adr;
	adr = VRAM_ADR + (uint32_t)ypos * LCG_C_SIZE + xpos;
	SPI_Mem_Write(adr, dat);
}

void vRam_Nread(uint8_t xpos,uint8_t ypos,char *ptn,uint8_t n){
	uint32_t adr;
	adr = VRAM_ADR + (uint32_t)ypos * LCG_C_SIZE + xpos;
	SPI_Mem_NRead(adr,(uint8_t *)ptn,n);
}

void vRam_Nwrite(uint8_t xpos,uint8_t ypos,char *ptn,uint8_t n){
	uint32_t adr;
	adr = VRAM_ADR + (uint32_t)ypos * LCG_C_SIZE + xpos;
	SPI_Mem_NWrite(adr,(uint8_t *)ptn,n);
}

//-------- G-LCD ------------------------------------
void gLCD_int (void){
    gCS_SetLow();                   // LCDZNgL
    gRS_SetLow();                   // R}hf[^w
    SPI1_ExchangeByte(0xAE);        // Display = OFF
    SPI1_ExchangeByte(0xA0);        // ADC = normal
    SPI1_ExchangeByte(0xC8);        // C.output = revers
    SPI1_ExchangeByte(0xA3);        // bias = 1/7
    SPI1_ExchangeByte(0x2C);        // power control 1
    __delay_ms(2);                  // 2mSx
    SPI1_ExchangeByte(0x2E);        // power control 2
    __delay_ms(2);                  // 2mSx
    SPI1_ExchangeByte(0x2F);   	    // power control 3
    SPI1_ExchangeByte(0x23);        // Vo ratio set
    SPI1_ExchangeByte(0x81);        // E-volume mode
    SPI1_ExchangeByte(0x1C);        // E-volume value
    SPI1_ExchangeByte(0xA4);        // S_Ȃ
    SPI1_ExchangeByte(0x40);        // start line = 0
    SPI1_ExchangeByte(0xA6);        // ]Ȃ
    SPI1_ExchangeByte(0xAF);        // Display = ON
    gCS_SetHigh();                  // LCDZNg
}

//-------- G-LCD̃f[^Siwf[^Ŗ߂j---
void gLCD_clr (char dat){			
    uint8_t x, y;
    gCS_SetLow();                   // gLCDZNgL
    for(y = 0; y < 6; y++){
        gRS_SetLow();               // R}hw
        SPI1_ExchangeByte(0xB0 + y);
        SPI1_ExchangeByte(0x10);
        SPI1_ExchangeByte(0x00);
        gRS_SetHigh();              // \f[^w
        for(x = 0; x < 128; x++){
            SPI1_ExchangeByte(dat);
        }
    }
    gCS_SetHigh();                  // LCDZNg
    for(y = 0; y < 6; y++){
        for(x = 0; x < 128; x++){
            vRam_write(x,y,dat);    // vRamNA
        }
    }
}

//-------- J[\ʒuw -----------------------------------
void gLCD_posXY(uint8_t xpos, uint8_t ypos){
    gCS_SetLow();                   // `bvZNgL
    gRS_SetLow();                   // R}hw
    SPI1_ExchangeByte(0xB0 | (ypos >> 3));
    SPI1_ExchangeByte(0x10 | (xpos >> 4));
    SPI1_ExchangeByte(xpos & 0x0F);
    gCS_SetHigh();                  // `bvZNg
}

//-------- oCgPʂŕ\ixposʒuԂj ---------
uint8_t gLCD_chrX(uint8_t xpos, uint8_t ypos, char chr){
    uint8_t i, sx, yAdr, ptn;
    chr -= 0x20;                    //zAhXvZ
    gLCD_posXY(xpos, ypos);         //\ʒuw
    sx = xpos;                      // posxۑ
    yAdr = ypos >> 3;
    gCS_SetLow();                   // `bvZNgL
    gRS_SetHigh();                  // \f[^w
    for(i = 0; i < 5; i++) {        //f[^Ɏ擾
        ptn = Font[chr][i];
        if(ptn == 0xFF)  break;     //Ȃ甲
        vBf[i] = ptn;
        SPI1_ExchangeByte(ptn);
        xpos++;
    }
    vBf[i] = 0;
    SPI1_ExchangeByte(0);           //Ԋu󂯂
    xpos++;
    gCS_SetHigh();                  // `bvZNg
    vRam_Nwrite(sx,ypos,(char *)vBf, i);    // vRamɏ 
    return xpos;                    //\ʒuԂ
}

//-------- oCgPʂŕ\ixposʒuԂj-----
uint8_t gLCD_strX(uint8_t xpos, uint8_t ypos, char *str){
    while(*str)  xpos = gLCD_chrX(xpos, ypos, *str++);
    return xpos;                    //\ʒuԂ
}

//-------- oCgPʂŃp^[\ixposʒuԂj-
uint8_t gLCD_ptnX(uint8_t xpos, uint8_t ypos, char *ptn, uint8_t n){
    uint8_t i, yAdr;
    gLCD_posXY(xpos, ypos);         // \ʒuw
    gCS_SetLow();                   // `bvZNgL
    gRS_SetHigh();                  // \f[^w
    yAdr = ypos >> 3;
    for(i = 0; i < n; i++){
         SPI1_ExchangeByte(*(ptn + i));
    }
    gCS_SetHigh();                  // `bvZNg
    vRam_Nwrite(xpos,ypos,ptn,n);
    return xpos + n;                  // \ʒuԂ
}

//---- oCgPʂn̎wf[^Ŗ߂ixposʒuԂj
uint8_t gLCD_clrX(uint8_t xpos, uint8_t ypos, char dat, uint8_t n){
    uint8_t i, yAdr;
    gLCD_posXY(xpos,ypos);          // \ʒuw
    gCS_SetLow();                   // `bvZNgL
    gRS_SetHigh();                  // \f[^w
    yAdr = ypos >> 3;
    for(i = 0; i < n; i++) {
        SPI1_ExchangeByte(dat);
    }
    gCS_SetHigh();                  // `bvZNg
    for(i=0;i<<n;i++){
        vRam_write(xpos,ypos,dat);       
    }
    return xpos+n;                  // JnʒuԂ
}

//---- oCgPʂŁicj16hbgp^[(Ȃǁj̕\
/*	xpos: XʒuA	ypos: Yʒu
 *	*pKj: p^[f[^|C^A cdt: hbg
 *---------------------------------------------------- */
uint8_t gLCD_nk16X(uint8_t xpos, uint8_t ypos, char *pKj, uint8_t cdt){
 	gLCD_ptnX(xpos, ypos,(char *)pKj, cdt); 
	xpos = gLCD_ptnX(xpos, ypos+8, (char *)(pKj + cdt),cdt);
	return xpos;
}
//---- p(8x16)\ixposʒuԂj-----
uint8_t gLCD_HchrX(uint8_t xpos, uint8_t ypos, uint8_t chCode){

    uint32_t adr;
    if((chCode >= 0x20) & (chCode < 0x7F)){
        adr = (chCode - 0x20) * 16 + HASC_OFS;
    }else{
        adr = H_BLANK;              // puN\
    }
    SPI_Mem_NRead(adr,(uint8_t *)vBf,16);
    xpos = gLCD_nk16X(xpos, ypos, (char *)vBf, 8);        
    return xpos;
}
//-------- oCgPʂŔp\ixposʒuԂj-----
uint8_t gLCD_HstrX(uint8_t xpos, uint8_t ypos, char *str){
    while(*str)  xpos = gLCD_HchrX(xpos, ypos, *str++);
    return xpos;                    //\ʒuԂ
}

//--- sNAĔp\ixposʒuԂj
uint8_t prtHstr_LnClr(uint8_t xpos, uint8_t ypos,char* str){
    gLCD_clrX(0,ypos  ,0,LCG_C_SIZE);
    #ifdef FONT_ROM
        gLCD_clrX(0,ypos+8,0,LCG_C_SIZE);
        return gLCD_HstrX(xpos,ypos,str);
    #else
        return  gLCD_strX(xpos,ypos,str);
    #endif
}

//--- [U[}bvǏo
void read_UsrMap(uint8_t p){
    uint32_t ad;
    ad = 0x00C00 + p * 128;
    SPI_Mem_NRead(ad,uMap,128);
}

//--- [U[i[AhX擾
uint32_t get_UFntAdr(uint16_t kCode){
    uint8_t pg,i;
    uint16_t *usrP;
    usrP = (uint16_t*)uMap;
    for(pg = 0; pg < 8; pg++){
        read_UsrMap(pg);
        for(i = 0; i < 64; i++){
            if(*usrP == 0xFFFF) return 0;
            if(*usrP == kCode)  return 0x1C000 + pg * 2048 + i * 32;
            usrP++;
        }
    }
    return 0;
}

/*--- JIS[VtgJISϊ
uint16_t Jis2SJis(uint16_t jCd){
	uint8_t hi,lo;
	hi = jCd >> 8;
	lo = (uint8_t)jCd;
    if(hi && 1){
        if(lo < 0x60)	lo = lo + 0x1F;
        else			lo = lo + 0x20;
    }else{				lo = lo + 0x7E;
	}
    if(hi < 0x5F)		hi = (hi + 0xE1) >> 1;
    else				hi = (hi + 0x161) >> 1;
    return (hi * 256 + lo);
}
*/
//---- VtgJIS[JISϊ
uint16_t SJis2Jis(uint16_t sCd){
	uint8_t hi,lo;
	hi = sCd >> 8;
	lo = (uint8_t)sCd;
    if(hi <= 0x9F){
        if(lo < 0x9F)	hi = hi * 2 - 0xE1;
        else			hi = hi * 2 - 0xE0;
	}else{
        if(lo < 0x9F)	hi = (hi - 0xB0) * 2 - 1;
        else            hi = (hi - 0xB0) * 2;
    }
    if(lo < 0x7F)		lo = lo - 0x1F;
    else{
		if(lo < 0x9F)	lo = lo - 0x20;
    	else        	lo = lo - 0x7E;
	}
    return (hi * 256 + lo);
}

//--- Sp(jtHgAhX擾)
uint32_t KfntAdr(uint16_t kCode){
	uint8_t msb, lsb;
    uint32_t lmsb, llsb;
	msb = kCode >> 8;
	lsb = (uint8_t)kCode & 0x000FF;
    lmsb = (uint32_t)msb;
    llsb = (uint32_t)lsb;
	if(msb>=0x21 & msb<0x30){
		if(msb==0x21){						// L1
			if(lsb>=0x21 & lsb<=0x7E) return 0x01000+(lsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
		}else if(msb==0x22){				// L2
			if(lsb>=0x21 & lsb<=0x2E) return 0x01C00+(lsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
		}else if(msb==0x23){				// ASCII
			if(lsb>=0x30 & lsb<=0x39) return 0x01E00+(lsb-0x30)*32;
			if(lsb>=0x41 & lsb<=0x5A) return 0x02000+(lsb-0x41)*32;
			if(lsb>=0x61 & lsb<=0x7A) return 0x02400+(lsb-0x61)*32;
			else 					  return get_UFntAdr(kCode);
		}else if(msb==0x24){
			if(lsb>=0x21 & lsb<=0x73) return 0x02800+(lsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
		}else if(msb==0x25){
			if(lsb>=0x21 & lsb<=0x76) return 0x03260+(lsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
		}
	}else if(msb<0x50){						// 
		if(msb!=0x4F){
			if(lsb>=0x21 & lsb<=0x7E) return 0x04000+(lmsb-0x30)*3008+(llsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
		}else{
			if(lsb>=0x21 & lsb<=0x53) return 0x1AC40+(llsb-0x21)*32;
			else 					  return get_UFntAdr(kCode);
        }
    }
	return get_UFntAdr(kCode);
}

//---- oCgPʂőSp(j\
uint8_t gLCD_ZchrX(uint8_t xpos, uint8_t ypos, uint16_t kCd,uint8_t ed){
	uint32_t adr;
    uint16_t kk;
    uint8_t h,l;
    if(ed & 0x01){
        h = (uint8_t)(kCd>>8);
        l = (uint8_t)kCd;
        kCd = l*256+h;
    }
    if(ed < 2)  kk = SJis2Jis(kCd);
    else        kk = kCd;
    adr = KfntAdr(kk);
//    printf(" %X %lX\r",kk,adr);
    SPI_Mem_NRead(adr,(uint8_t *)vBf,32);
	if(adr)	return gLCD_nk16X(xpos,ypos,(char *)vBf,16);
	return xpos;
}

//---- oCgPʈʒuőSp(j\
uint8_t gLCD_ZstrX(uint8_t xpos, uint8_t ypos, char *str,uint8_t ed){
	uint16_t cd, *kjP;
    kjP = (uint16_t *)str;
	while(*kjP & 0xFF){
		xpos = gLCD_ZchrX(xpos,ypos,*kjP,ed);
		kjP++;
	}
	return xpos;
}		

/****** hbgPʈʒuŕ` ******/
//----------hbgPʂœ_`----------------------
void gLCD_PSet(uint8_t xpos, uint8_t ypos, uint8_t col){
    uint8_t yAdr, yBit;         // yAhXArbgʒu
    uint8_t ptn = 0x01;         // rbgp^[
    uint8_t dat;
    if((xpos > 127) || (ypos > 47))  return;
    dat = vRam_read(xpos, ypos);
    yAdr = ypos >> 3; yBit = ypos & 0x07;
    ptn <<= yBit;
    switch(col){
        case 0:	dat &= (~ptn);	break;
        case 1: dat |= ptn;		break;
        case 8: dat ^= ptn;		break;
    }
    gLCD_posXY(xpos,ypos);  
    gCS_SetLow();                   // `bvZNgL
    gRS_SetHigh();                  // \f[^w
    SPI1_ExchangeByte(dat);
    gCS_SetHigh();                  // `bvZNg
    vRam_write(xpos, ypos, dat);
}

//-------hbgPʂŕ`ixposʒuԂj-------
uint8_t gLCD_PutChr(uint8_t xpos, uint8_t ypos, char ch, uint8_t col){
    uint8_t i, j, ptn, msk;      //rbg}XNf[^
    //LtHgf[^łȂȂ牽Ȃ
    if((ch < 0x20)||(ch > 0x7f)) return xpos;
    ch -= 0x20;                     //zAhXvZ
    for(i = 0; i < 5; i++){
        msk = 0x01;
        ptn = (uint8_t)Font[ch][i];
        if(ptn == 0xFF) break;      //Ȃ甲
        for(j = 0; j < 8; j++){
            if(ptn & msk)    gLCD_PSet(xpos + i,ypos + j,col);
            msk <<= 1;
        }
    } 
    return xpos + i + 1;
}

//-------hbgPʂŕ`ixposʒuԂj---
uint8_t gLCD_PutStr(uint8_t xpos, uint8_t ypos, char * str, uint8_t col){
    while(*str)                     //I[܂Ōp
        xpos = gLCD_PutChr(xpos,ypos,*str++,col);
    return xpos;                    //\ʒuԂ
}

//-------hbgPʂŃp^[`ixposʒuԂj-------
uint8_t gLCD_PutPtn(uint8_t xpos, uint8_t ypos, char * ptn, uint8_t n, uint8_t col){
    uint8_t i, j, msk;         //rbg}XNf[^
    for(i = 0; i < n; i++){
        msk = 0x01;
        for(j = 0; j < 8; j++){
            if(*ptn & msk)    gLCD_PSet(xpos+i,ypos+j,col);
            msk <<= 1;
        }
        ptn++;
    }
    return xpos + i;
}

// --- ABSASWAP֐`

void swap_uint8_t(uint8_t *a, uint8_t *b){
	uint8_t tmp; tmp = *a; *a = *b; *b = tmp;
}
#define ABS(a)    (((a)>0) ? (a) : -(a))

//----------hbgPʂŒ`-------------------
void gLCD_Line(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1, uint8_t col){
    uint8_t steep, x, y, tmp;
    int   ystep, deltax, deltay, error;
    steep = (ABS(y1 - y0) > ABS(x1 - x0));
    if(steep){    swap_uint8_t(&x0,&y0); swap_uint8_t(&x1,&y1); }
    if(x0 > x1){  swap_uint8_t(&x0,&x1); swap_uint8_t(&y0,&y1); }
    deltax = x1 - x0;                       //  XvZ
    deltay = abs(y1 - y0);
    error = 0;
    y = y0;
    if(y0 < y1) ystep = 1; else ystep = -1;
    for(x = x0; x < x1 + 1; x++){
        if(steep) gLCD_PSet(y,x,col); 
        else      gLCD_PSet(x,y,col);
        error += deltay;
        if((error << 1) >= deltax){
            y += ystep;
            error -= deltax;
        }
    }
}

//---- hbgPʂ(cj16hbgp^[(Ȃǁj̕\ixposʒuԂj
/*	xpos: XʒuA	ypos: Yʒu,		col: \[h
 *	*pKj: p^[f[^|C^A	cdt: hbg
 *---------------------------------------------------- */
uint8_t Put_nK16(uint8_t xpos, uint8_t ypos, char *pKj, uint8_t cdt, uint8_t col){
 	gLCD_PutPtn(xpos, ypos, (char *)pKj, cdt, col); 
	xpos = gLCD_PutPtn(xpos, ypos+8, (char *)(pKj + cdt),cdt, col);
	return xpos;
}

//---- hbgPʂŔp\ixposʒuԂj
uint8_t Put_HchrX(uint8_t xpos, uint8_t ypos, uint8_t chCode,uint8_t col){
    uint32_t adr;
    if((chCode >= 0x20) & (chCode < 0x7F)){
        adr = (chCode - 0x20) * 16 + HASC_OFS;
    }else{
        adr = H_BLANK;              // puN
    }
    SPI_Mem_NRead(adr,(uint8_t *)vBf,16);
    xpos = Put_nK16(xpos, ypos, (char *)vBf, 8, col);       
    return xpos;
}

//---- hbgPʂŔp\ixposʒuԂj
uint8_t Put_HstrX(uint8_t xpos, uint8_t ypos, char *str, uint8_t col){
    while(*str)  xpos = Put_HchrX(xpos, ypos, *str++, col);
    return xpos;                    //\ʒuԂ
}
/*****  End of File   *****/
