/******************************(spi_Mem3npf.c)***************
 *	SPIڑ(25LC1024/23LCV1024)ǂݏCu
 ***********************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "myProject.h"

//=== O[oϐ ============
char     Dlm[] = ",";                   // ؂f~^
char     SBuf[20];                      // 񏈗pobt@[

//--- SPI[p
static uint32_t CrtAdr = 0;             // JgAhX
static uint8_t  DBuf[MBFSIZE];          // y[Wpobt@[
static uint8_t  SqMode = 0;             // V[PX[htO
static char     lstCmd;                 // ŏIR}h
static uint8_t  spiRom = 1;             // spiRomǂ
static uint16_t lstChr = 0;             // ŏI\

/*************************************
 *  SPIC EEPROM function
 **************************************/
 
//---- ROMXe[^X̓ǂݏo
uint8_t SPI_Rom_RdStat(){           // ROM̂ݎgp
	uint8_t stat;
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_RD_STATS);
	stat = SPI1_ExchangeByte(0xAA);	// 0xAA̓_~[
	CS0_SetHigh();
	return stat;
}

//---- R}h24rbgAhX𑗐M 
void sendAdr(uint8_t cmd, uint32_t adr){
    if(spiRom) CS0_SetLow();		// spiRom(25LC1024)I
    else       CS1_SetLow();		// spiRam(23LCV1024)I
	SPI1_ExchangeByte(cmd);			// send Command
	SPI1_ExchangeByte((uint8_t)(adr>>16));
	SPI1_ExchangeByte((uint8_t)(adr>>8));
	SPI1_ExchangeByte((uint8_t)adr);
} 
 
//-----  AhXadrA1oCgǂݏo
uint8_t SPI_Mem_Read(uint32_t adr){
	uint8_t dat;
    if(adr < 0x80000) spiRom = 1;	// spiRom(25LC1024)w
    else              spiRom = 0;	// spiRam(23LCV1024)w
	sendAdr(SPIMEM_READcmd,adr);    // send Read_CMD & Address
	dat = SPI1_ExchangeByte(0xAA);
    if(spiRom) CS0_SetHigh();		// spiRom̏ꍇ
    else       CS1_SetHigh();		// spiRam̏ꍇ
	return dat;
}

//-----  AhXadrɁA1oCgdt
uint8_t SPI_Mem_Write(uint32_t adr, uint8_t dat){
    if(adr < 0x80000){
        spiRom = 1;	// spiRom(25LC1024)w
        CS0_SetLow();
        SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
        CS0_SetHigh();
    }else              spiRom = 0;	// spiRam(23LCV1024)w   
	sendAdr(SPIMEM_WRITEcmd,adr);   // send Write_CMD & Address
	SPI1_ExchangeByte(dat);
    if(spiRom){						// spiRom̏ꍇ
		CS0_SetHigh();
		__delay_ms(6);
    }else{							// spiRam̏ꍇ
		CS1_SetHigh();
	}
    return dat;
}

//-----  AhXadr炎oCgary[]ɓǂݏo
void SPI_Mem_NRead(uint32_t adr,uint8_t *ary,uint16_t cnt){
    if(adr < 0x80000) spiRom = 1;	// spiRom(25LC1024)w
    else              spiRom = 0;	// spiRam(23LCV1024)w
	sendAdr(SPIMEM_READcmd,adr);    // send Read_CMD & Address
	SPI1_ReadBlock(ary,cnt);        // block read
	if(spiRom){
		CS0_SetHigh();
    	while(SPI_Rom_RdStat() & 1);
    }else{
		CS1_SetHigh();
	}    
}

//-----  AhXadrary[]noCg
void SPI_Mem_NWrite(uint32_t adr,uint8_t *ary,uint16_t cnt){
    if(adr < 0x80000){
        spiRom = 1;	// spiRom(25LC1024)w
        CS0_SetLow();
        SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
        CS0_SetHigh();
    }else{
        spiRom = 0;	// spiRam(23LCV1024)w
    }
    sendAdr(SPIMEM_WRITEcmd,adr);   // send Write_CMD & Address
	SPI1_WriteBlock(ary,cnt);	//  block write
	if(spiRom){
		CS0_SetHigh();
    	while(SPI_Rom_RdStat() & 1);
    }else{
		CS1_SetHigh();
	}
}

/****** ėpTu[`@********************/
//   16iϊ  uint16 -> str(Hex)
uint8_t my_utoa2(uint16_t n){
    n &= 0x0F;
    if(n < 10)  return '0'+ (uint8_t)n;
    else        return 'A'+ ((uint8_t)n - 10);
}

void my_utoa(uint8_t *str, uint16_t wd, uint8_t dg){
    if(dg > 3)  *str++ = my_utoa2(wd >> 12);
    if(dg > 2)  *str++ = my_utoa2(wd >> 8);
    if(dg > 1)  *str++ = my_utoa2(wd >> 4);
    *str++ = my_utoa2(wd);
    *str = '\0';
}

//---- 16i10iɕϊ
uint32_t my_xtoi(char *str){
    uint32_t dec;
    dec = strtoul(str,NULL,16);
    return (uint32_t)dec;
}

//---  o͊֐iWo͂ցj
void my_puts(char *str){            // ̂ݏo
	while(*str) putch(*str++);
}

void my_putsLf(char *str){          // sɈړiLF)t
    my_puts(str);
    putch('\r');
}

//---- y[Wobt@[vg
void prt_PBf(){
    uint16_t i;
    for(i = 0; i < MBFSIZE; i++){            // 16~8s\
        if(i % 16 == 0) putch('\r');
        my_utoa((uint8_t *)SBuf,DBuf[i],2);
        putch(SBuf[0]); putch(SBuf[1]); putch(' ');
//        printf(" %02X",DBuf[i]);
    }
    puts("\r");
}

//---- 20rbgAhX8rbgf[^16iŕɊi[
void sPrt_AdrDt(char *strP,uint32_t adr, uint8_t dt, char ch){
//        sprintf(strP,"%05lX < %02X",adr,dt);  ch='>' or ch='<'
	uint16_t a16;
	uint8_t  h;
	h = (uint8_t)((adr>>16) & 0x0F);
	*strP++ = my_utoa2(h);
	a16 = (uint16_t)(adr & 0x0FFFF);
	my_utoa((uint8_t *)strP,a16,4);
	strP += 4;
	*strP++ = ' '; *strP++ = ch; *strP++ =' ';
	my_utoa((uint8_t *)strP,(uint16_t)dt,2);
	strP += 2;
	*strP = '\0';
}

//---- 20rbgAhX120rbgAhX216iŕɊi[
void sPrt_AdrAdr(char *strP,uint32_t adr1, uint32_t adr2, char ch){
//    sprintf(strP,"%05lX - %05lX", ad1, ad2);   ch='-'
	uint16_t a16;
	uint8_t  h;
	h = (uint8_t)((adr1>>16) & 0x0F);
	*strP++ = my_utoa2(h);
	a16 = (uint16_t)(adr1 & 0x0FFFF);
	my_utoa((uint8_t *)strP,a16,4);
	strP += 4;
	*strP++ = ' '; *strP++ = ch; *strP++ =' ';
	h = (uint8_t)((adr2>>16) & 0x0F);
	*strP++ = my_utoa2(h);
	a16 = (uint16_t)(adr2 & 0x0FFFF);
	my_utoa((uint8_t *)strP,a16,4);
	strP += 4; 
	*strP = '\0';
}

/************************************
 * 	R}hANV
 ************************************/
//----- vR}h   W[aaaa][,[d0,[,]]]
uint16_t spiMem_cmd_W(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  last;                      // ̍Ō̈ʒu
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt = 0;                    // ރoCgf[^
    uint16_t cnt = 0;                   // ۂɏ񂾃oCg

    lstCmd = str[0];
    if(strlen(str)==1){                 // 'W'݂̂Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        return 0;                       // f[^͏܂Ȃ
    }
    last = (uint8_t)strlen(str)-1;      // ̍sʒu擾
    if(str[last] == ','){               // sR}Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        str[last]='\0';                 // s̃R}
    }
    if(str[1]!=','){                    // 2R}H
        pt = strtok(str+1,Dlm);         // R}h̎
        if(pt != NULL){                 // AhXf[^
            res = my_xtoi(pt);
            CrtAdr = res;
        }
        pt = strtok(NULL,Dlm);          // 捞
    }else{
        pt = strtok(str+1,Dlm);         // 捞
    } 
    do{
        if(pt != NULL){                 // f[^邩H
            res = my_xtoi(pt);
            dt = (uint8_t)res;
 
            if(lstCmd=='W'){
                SPI_Mem_Write(CrtAdr,dt);   // f[^
            }else if(lstCmd == 'S'){
                DBuf[CrtAdr & 0x7F]= dt;  
            }
			sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
//            sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
            my_putsLf(SBuf);
//            printf("%s\r",SBuf);
            prtHstr_LnClr(0,16,SBuf);
            CrtAdr++; cnt++;          
            pt = strtok(NULL,Dlm);      // 
        }
    }while(pt != NULL);                 // f[^邾JԂ
    return cnt;                         // 񂾕Ԃ
}

//---- qR}h  R[aaaa][,n]
uint16_t spiMem_cmd_R(char *str){
    char *pt;                           // 񑀍p|C^
    uint16_t n = 1;                     // w肳ꂽǍoCg
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt;                        // ǂݍ񂾃oCgf[^
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg
    uint16_t i;                         // [vϐ
    
    lstCmd = str[0];
    if(strlen(str) > 1){
        if(str[1]==','){
            pt = strtok(str+2,Dlm);
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }else{
            pt = strtok(str+1,Dlm);
            if(pt != NULL){             // address?
                res = my_xtoi(pt);
                CrtAdr = res;
            }
            pt = strtok(NULL,Dlm);      // 
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }
    }
    for(i = 0; i < n; i++ ){
        dt = SPI_Mem_Read(CrtAdr);      // f[^ǂݏo
		sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
//        sprintf(SBuf,"%05lX > %02X",CrtAdr,dt);
        my_putsLf(SBuf);
//        printf("%s\r",SBuf);
        prtHstr_LnClr(0,16,SBuf);
        CrtAdr++; cnt++;
    }
    SqMode = 0;
    return cnt;                         // ǂݍ񂾃f[^Ԃ
}

//---- WSQ iA[hj
uint16_t spiMem_cmd_WSQ(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  dt;                        // ރoCgf[^
    uint32_t res;                       // Hexlϊ
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg

    pt = strtok(str,Dlm);
    while(pt != NULL){                  // f[^邾JԂ
        res = my_xtoi(pt);
        dt = (uint8_t)res;
        if(lstCmd == 'W'){
            SPI_Mem_Write(CrtAdr,dt);       // f[^
        }else if(lstCmd=='S'){
			DBuf[CrtAdr & 0x7F]= dt;  
        }
		sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
//        sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
        my_putsLf(SBuf);
//     	  printf("%s\r",SBuf);
        prtHstr_LnClr(0,16,SBuf);
        CrtAdr++; cnt++;
        pt = strtok(NULL,Dlm);          // 
    }
    return cnt;                         // 񂾃f[^Ԃ
}

//---- pR}hiA[h̉j   Q
void spiMem_cmd_Q(char *str){
    lstCmd = str[0];
	SqMode = 0;
	#ifndef VBA
		puts("SqMode OFF\r");
	#endif
}

//---- t(dump)R}h    U[aaaa]
//         i64oCg̃f[^DBuf[]ɓǂݏo)
int spiMem_cmd_U(char *str){
    char    *pt;                        // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    pt = strtok(str+1,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFF80;               // 128oCgPʂ 
    SPI_Mem_NRead(ad, DBuf, MBFSIZE);          // 128oCgDBuf[]ɓǏo
	sPrt_AdrAdr(SBuf,ad,ad + MBFSIZE - 1,'-');
//    sprintf(SBuf,"%05lX - %05lX", ad, ad+127);
    my_puts(SBuf);
//    printf("%s",SBuf);
    prtHstr_LnClr(0,16,SBuf);
    prt_PBf();
    SqMode = 0;
    return 0;
}

//---- o(Page)R}h    PW[aaaa]
//          iDBuf[]64oCgɏށj
int spiMem_cmd_P(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    if(strlen(str)==1){
        puts("PageBuffer");
//        printf("PageBuffer");
        prt_PBf();
        return 0;
    }
    if(str[1]=='R'){
        spiMem_cmd_U(str+1);
        return 0;
    }
    if(str[1] != 'W') return -1;        // 2vH
    pt = strtok(str+2,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFF80;              // 128oCgPʂ
    SPI_Mem_NWrite(ad,DBuf,MBFSIZE);         // DBuf[]128oCg
	sPrt_AdrAdr(SBuf,ad,ad + MBFSIZE - 1,'-');
//    sprintf(SBuf,"PW:%05lX - %05lX",ad,ad+127);
    my_putsLf(SBuf);
//     	printf("%s\r",SBuf);   
    prtHstr_LnClr(0,16,SBuf);
    SqMode = 0;    
    return 0;
}

//----  V[PX[h̊mF
uint8_t spiMem_SqMode(){
	return SqMode;
}

//---- K(j\R}h  K[H][n] 
int spiMem_cmd_K(char *str){
    char     *kp;                       // 񑀍p|C^
    uint8_t i;
    kp = (char *)DBuf;
    if(str[1] == 'H'){                  // 2HH
		if(strlen(str)>2){              // AhXf[^L
			spiMem_cmd_U(str+1);        // y[Wf[^DBufɓǂݍ
		}
        for(i = 0; i < 16; i++){
            gLCD_nk16X(8*i,32,kp+16*i,8);
        }
    }else{                              // Sp̏ꍇ
		if(strlen(str)>1){              // AhXf[^L
			spiMem_cmd_U(str);          // y[Wf[^DBufɓǂݍ
		}
        for(i = 0;i < 8; i++){
            gLCD_nk16X(16*i,32,kp+32*i,16);
        }      
    }
    SqMode = 0;
    return i;
}

//---- L(j\R}h  L[n] iR[hj
void spiMem_cmd_L(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint16_t ftCd = 0;                   // tHgR[h
    
    lstCmd = str[0];
    if(strlen(str)==1){					// AhX	
		ftCd = lstChr + 1;              // 
	}else{
    	pt = strtok(str+1,Dlm);
    	if(pt != NULL){                 // AhXLH
        	res = my_xtoi(pt);
			if(res>0) 	ftCd = (uint16_t)res;
		}
	}
	if(ftCd<256)	gLCD_HchrX(0,32,(uint8_t)ftCd);
	else			gLCD_ZchrX(0,32,ftCd,2);
	lstChr = ftCd;
    my_utoa((uint8_t *)SBuf,lstChr,4); my_putsLf(SBuf);
    SqMode = 0;
}

/******* End of File ********/
